---
title: columns
slug: Web/CSS/columns
tags:
  - CSS
  - CSS Multi-column Layout
  - CSS Property
  - Reference
  - 'recipe:css-shorthand-property'
---
<div>{{CSSRef}}</div>

<p>The <strong><code>columns</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> shorthand property sets the number of columns to use when drawing an element's contents, as well as those columns' widths.</p>

<div>{{EmbedInteractiveExample("pages/css/columns.html")}}</div>

<h2 id="Constituent_properties">Constituent properties</h2>

<p>This property is a shorthand for the following CSS properties:</p>

<ul>
 <li><a href="/en-US/docs/Web/CSS/column-count"><code>column-count</code></a></li>
 <li><a href="/en-US/docs/Web/CSS/column-width"><code>column-width</code></a></li>
</ul>

<h2 id="Syntax">Syntax</h2>

<pre class="brush:css no-line-numbers notranslate">/* Column width */
columns: 18em;

/* Column count */
columns: auto;
columns: 2;

/* Both column width and count */
columns: 2 auto;
columns: auto 12em;
columns: auto auto;

/* Global values */
columns: inherit;
columns: initial;
columns: unset;</pre>

<p>The <code>columns</code> property may be specified as one or two of the values listed below, in any order.</p>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>&lt;'column-width'&gt;</code></dt>
 <dd>The ideal column width, defined as a {{cssxref("&lt;length&gt;")}} or the keyword <code>auto</code>. The actual width may be wider or narrower to fit the available space. See {{cssxref("column-width")}}.</dd>
 <dt><code>&lt;'column-count'&gt;</code></dt>
 <dd>The ideal number of columns into which the element's content should be flowed, defined as an {{cssxref("&lt;integer&gt;")}} or the keyword <code>auto</code>. If neither this value nor the column's width are <code>auto</code>, it merely indicates the maximum allowable number of columns. See {{cssxref("column-count")}}.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Setting_three_equal_columns">Setting three equal columns</h3>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;p class="content-box"&gt;
  This is a bunch of text split into three columns
  using the CSS `columns` property. The text
  is equally distributed over the columns.
&lt;/p&gt;
</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css; notranslate">.content-box {
  columns: 3 auto;
}</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample('Setting_three_equal_columns', 'auto', 120)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS3 Multicol', '#columns', 'columns')}}</td>
   <td>{{Spec2('CSS3 Multicol')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.columns")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{cssxref("widows")}}</li>
 <li>{{cssxref("orphans")}}</li>
 <li><a href="/en-US/docs/Web/CSS/Paged_Media">Paged media</a></li>
 <li><a href="/en-US/docs/Learn/CSS/CSS_layout/Multiple-column_Layout">Multiple-column Layout</a> </li>
</ul>
